% 11/30/2018 Makoto. Created for Christiane.

        % % This is the data structure under STUDY.
        % STUDY.measureProjection.erp.projection.domain(1)
        % 
        % % This is the command line to show the 3-D blob.
        % STUDY.measureProjection.erp.projection.domain(1).plotVolume;
        % 
        % % This is the command line to show the voxels.
        % STUDY.measureProjection.erp.projection.domain(1).plotVoxel;
        % 
        % % The above command refers to this function, line 410.
        % % /data/projects/makoto/Tools/eeglab14_1_2b/plugins/bigdelys-measure-projection-16dfcad30443/+pr/domain
        % 
        % % Plot the figures
        % plottingColor = [1 0 0];
        % 
        % % Plot 3-D blob.
        % surfaceOptions = {};
        % plotOptions    = {};
        % figure
        % plot_dipplot_with_cortex;
        % pr.plot_head_surface(obj.headGrid, obj.membershipCube, 'surfaceColor', plottingColor, 'surfaceOptions', surfaceOptions, plotOptions{:});
        % 
        % % Plot 3-D cubes.
        % regionOptions = {};
        % figure
        % plot_dipplot_with_cortex;
        % pr.plot_head_region( obj.headGrid, obj.membershipCube, 'regionColor',  plottingColor, 'regionOptions',  regionOptions);
        % 
        % 
        % headGrid       = obj.headGrid;
        % membershipCube = obj.membershipCube;
        % 
        % save /data/projects/makoto/Tools/strippingMeasureProjection/headGrid headGrid
        % save /data/projects/makoto/Tools/strippingMeasureProjection/membershipCube membershipCube

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Plot the figure outside Measure Projection %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load('/data/projects/makoto/Tools/strippingMeasureProjection/headGrid')
load('/data/projects/makoto/Tools/strippingMeasureProjection/membershipCube')

% Plot the figures
plottingColor = [1 0 0];

% Plot 3-D blob.
surfaceOptions = {};
plotOptions    = {};
figure
plot_dipplot_with_cortex;
pr.plot_head_surface(headGrid, membershipCube, 'surfaceColor', plottingColor, 'surfaceOptions', surfaceOptions, plotOptions{:});

% Plot 3-D cubes.
regionOptions = {};
figure
plot_dipplot_with_cortex;
pr.plot_head_region(headGrid, membershipCube, 'regionColor',  plottingColor, 'regionOptions',  regionOptions);

%% Test--worked!! Independent on launched Measure Projection environment now.
load('/data/projects/makoto/Tools/strippingMeasureProjection/headGrid')
load('/data/projects/makoto/Tools/strippingMeasureProjection/membershipCube')
cd /data/projects/makoto/Tools/strippingMeasureProjection

% Plot 3-D blob.
surfaceOptions = {};
plotOptions    = {};
figure
plot_dipplot_with_cortex;
plot_head_surface(headGrid, membershipCube, 'surfaceColor', plottingColor, 'surfaceOptions', surfaceOptions, plotOptions{:});

% Plot 3-D cubes.
regionOptions = {};
figure
plot_dipplot_with_cortex;
plot_head_region(headGrid, membershipCube, 'regionColor',  plottingColor, 'regionOptions',  regionOptions);

%% Now, how do we define 'membershipCube'?

% Set Gaussian smoothing kernel
    % FWHM = 2.355*sigma See https://en.wikipedia.org/wiki/Full_width_at_half_maximum
    % 4.2  (FWHM==10mm, 12/23/2015)
    % 8.5  (FWHM==20mm, 06/24/2015)
    % 12.8 (FWHM==30mm, 09/05/2014)
    % 17.1 (FWHM==40mm, 01/06/2015)
    % Note that Gaussian is NOT truncated until reaching 150mm apart from the center

EEG = pop_loadset('filename','subj01.set','filepath','/data/projects/makoto/Hemifield/p06_epoched/');
for n = 1:length(EEG.dipfit.model)
    dipoleInfo.location(n,:) = EEG.dipfit.model(n).posxyz;
end

userInputKernelSize = 20;
standardDeviationOfEstimatedDipoleLocation = userInputKernelSize/2.355; % this calculates sigma in Gaussian equation
parametersForProjection = projectionParameter(standardDeviationOfEstimatedDipoleLocation);
parametersForProjection.numberOfStandardDeviationsToTruncatedGaussaian = 1.5;
%[~,~,gaussianWeightMatrix] = pr.meanProjection.getProjectionMatrix(uniqueDipole, headGrid, parametersForProjection);
[projectionMatrix, totalDipoleDenisty, gaussianWeightMatrix] = getProjectionMatrix(dipoleInfo, headGrid, parametersForProjection);

% Obtain inside-brain inclusive mask.
insideBrainInclusiveMaskIdx = find(vec(headGrid.insideBrainCube));

% Create a mask for inside-brain inclusive voxel mask on 27x23x23 tensor.
emptyBrainSpace1D = vec(zeros(headGrid.cubeSize));
emptyBrainSpace1D(insideBrainInclusiveMaskIdx) = sum(gaussianWeightMatrix);
emptyBrainSpace3D = reshape(emptyBrainSpace1D, headGrid.cubeSize);

figure
for n = 1:size(emptyBrainSpace3D,3)
    subplot(4,6,n)
    imagesc(emptyBrainSpace3D(:,:,n), [0 0.05]);
    colormap jet
end

% Plot 3-D blob.
plottingColor = [1 0 0];
surfaceOptions = {};
plotOptions    = {};
figure
plot_dipplot_with_cortex;
plot_head_surface(headGrid, logical(emptyBrainSpace3D), 'surfaceColor', plottingColor, 'surfaceOptions', surfaceOptions, plotOptions{:});

% Plot 3-D cubes.
regionOptions = {};
figure
plot_dipplot_with_cortex;
plot_head_region(headGrid, logical(emptyBrainSpace3D), 'regionColor',  plottingColor, 'regionOptions',  regionOptions);

%% Show two ROIs with different color.
load('/data/projects/makoto/Tools/strippingMeasureProjection/headGrid')
load('/data/projects/makoto/Tools/strippingMeasureProjection/membershipCube')
EEG = pop_loadset('filename','subj01.set','filepath','/data/projects/makoto/Hemifield/p06_epoched/');
for n = 1:length(EEG.dipfit.model)
    dipoleInfo.location(n,:) = EEG.dipfit.model(n).posxyz;
end

userInputKernelSize = 20;
standardDeviationOfEstimatedDipoleLocation = userInputKernelSize/2.355; % this calculates sigma in Gaussian equation
parametersForProjection = projectionParameter(standardDeviationOfEstimatedDipoleLocation);
parametersForProjection.numberOfStandardDeviationsToTruncatedGaussaian = 3;
[projectionMatrix, totalDipoleDenisty, gaussianWeightMatrix] = getProjectionMatrix(dipoleInfo, headGrid, parametersForProjection);

% Obtain inside-brain inclusive mask.
insideBrainInclusiveMaskIdx = find(vec(headGrid.insideBrainCube));

% Plot IC20 and IC21.
emptyBrainSpace1D_IC20 = vec(zeros(headGrid.cubeSize));
emptyBrainSpace1D_IC20(insideBrainInclusiveMaskIdx) = gaussianWeightMatrix(20,:);
emptyBrainSpace3D_IC20 = reshape(emptyBrainSpace1D_IC20, headGrid.cubeSize);
emptyBrainSpace1D_IC21 = vec(zeros(headGrid.cubeSize));
emptyBrainSpace1D_IC21(insideBrainInclusiveMaskIdx) = gaussianWeightMatrix(21,:);
emptyBrainSpace3D_IC21 = reshape(emptyBrainSpace1D_IC21, headGrid.cubeSize);

% figure
% for n = 1:size(emptyBrainSpace3D_IC20,3)
%     subplot(4,6,n)
%     imagesc(emptyBrainSpace3D_IC20(:,:,n));
%     colormap jet
% end

% Plot 3-D blob.
plottingColor_IC20 = [1 0 0];
plottingColor_IC21 = [0 0 1];
surfaceOptions = {'FaceAlpha' '0.4'};
plotOptions    = {};
figure
plot_dipplot_with_cortex;
plot_head_surface(headGrid, logical(emptyBrainSpace3D_IC20), 'surfaceColor', plottingColor_IC20, 'surfaceOptions', surfaceOptions, plotOptions{:});
plot_head_surface(headGrid, logical(emptyBrainSpace3D_IC21), 'surfaceColor', plottingColor_IC21, 'surfaceOptions', surfaceOptions, plotOptions{:});

% Plot 3-D cubes.
regionOptions = {};
figure
plot_dipplot_with_cortex;
plot_head_region(headGrid, logical(emptyBrainSpace3D_IC20), 'regionColor',  plottingColor_IC20, 'regionOptions',  regionOptions);
plot_head_region(headGrid, logical(emptyBrainSpace3D_IC21), 'regionColor',  plottingColor_IC21, 'regionOptions',  regionOptions);

%% Try the new function.
%EEG = pop_loadset('filename','subj01.set','filepath','/data/projects/makoto/Hemifield/p06_epoched/');
input1 = ALLEEG(1,1).dipfit.model(20).posxyz;
input2 = ALLEEG(1,1).dipfit.model(21).posxyz;

nimasImagesfromMpA({input1 input2}, 'blobOrCube', 'blob', 'FWHM', 8, 'voxelSize', 3, 'numGaussTrunc', 3)
nimasImagesfromMpA({input1 input2}, 'blobOrCube', 'cube', 'FWHM', 8, 'voxelSize', 3, 'numGaussTrunc', 3)

% This function is done. 